commit 6d75a89d2f506f88cfddf092440af5b2d54f07df
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Dec 21 18:01:26 2025 +0000

    Invalidate more variables at smtp-reset

diff --git a/src/src/deliver.c b/src/src/deliver.c
index cf3a41156..a984ee21e 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -174,8 +174,10 @@ deliver_set_expansions(address_item * addr)
 {
 if (!addr)
   {
-  const uschar ***p = address_expansions;
-  while (*p) **p++ = NULL;
+  for (const uschar ***p = address_expansions; *p; ) **p++ = NULL;
+  deliver_host_port = 0;
+  deliver_recipients = NULL;
+  router_var = NULL;
   return;
   }
 
diff --git a/src/src/globals.c b/src/src/globals.c
index 2d1354236..d04feb24f 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -188,6 +188,8 @@ when verifying one address while routing/verifying another. We have to have
 the size explicit, because it is referenced from more than one module. */
 
 const uschar **address_expansions[ADDRESS_EXPANSIONS_COUNT] = {
+  CUSS &address_file,
+  CUSS &address_pipe,
   CUSS &deliver_address_data,
   CUSS &deliver_domain,
   CUSS &deliver_domain_data,
@@ -198,12 +200,13 @@ const uschar **address_expansions[ADDRESS_EXPANSIONS_COUNT] = {
   CUSS &deliver_localpart_orig,
   CUSS &deliver_localpart_parent,
   CUSS &deliver_localpart_prefix,
+  CUSS &deliver_localpart_prefix_v,
   CUSS &deliver_localpart_suffix,
+  CUSS &deliver_localpart_suffix_v,
   CUSS (uschar **)(&deliver_recipients),
   CUSS &deliver_host,
+  CUSS &deliver_host_address,
   CUSS &deliver_home,
-  CUSS &address_file,
-  CUSS &address_pipe,
   CUSS &self_hostname,
   NULL };
 
diff --git a/src/src/log.c b/src/src/log.c
index 41f91a1ad..64587a9f2 100644
--- a/src/src/log.c
+++ b/src/src/log.c
@@ -1323,7 +1323,7 @@ va_end(ap);
 }
 
 /* As the above, but adds in LOG_PANIC_DIE.
-We have this as a wripper so that we can mark it as never returning,
+We have this as a wrapper so that we can mark it as never returning,
 for the benefit of static analysers. */
 
 void
diff --git a/src/src/macros.h b/src/src/macros.h
index 6c7d8b085..0070ef7ed 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -119,7 +119,7 @@ don't make the file descriptors two-way. */
 verifying. This has to be explicit because it is referenced in more than one
 source module. */
 
-#define ADDRESS_EXPANSIONS_COUNT 19
+#define ADDRESS_EXPANSIONS_COUNT 21
 
 /* The maximum permitted number of command-line (-D) macro definitions. We
 need a limit only to make it easier to generate argument vectors for re-exec
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index abc893ddc..da919048c 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -1736,6 +1736,8 @@ Returns:    a replacement reset point
 rmark
 smtp_reset(rmark reset_point)
 {
+deliver_set_expansions(NULL);
+
 recipients_list = NULL;
 rcpt_count = rcpt_defer_count = rcpt_fail_count =
   raw_recipients_count = recipients_count = recipients_list_max = 0;
@@ -1760,11 +1762,8 @@ f.active_local_from_check = local_from_check;		/* Can be set by ACL */
 f.active_local_sender_retain = local_sender_retain;	/* Can be set by ACL */
 sending_ip_address = NULL;
 return_path = sender_address = NULL;
-deliver_localpart_data = deliver_domain_data =
 recipient_data = sender_data = NULL;			/* Can be set by ACL */
 recipient_verify_failure = NULL;
-deliver_localpart_parent = deliver_localpart_orig = NULL;
-deliver_domain_parent = deliver_domain_orig = NULL;
 callout_address = NULL;
 submission_name = NULL;					/* Can be set by ACL */
 raw_sender = NULL;                  /* After SMTP rewrite, before qualifying */
@@ -1778,7 +1777,6 @@ dnslist_domain = dnslist_matched = NULL;
 
 dsn_ret = 0;
 dsn_envid = NULL;
-deliver_host = deliver_host_address = NULL;	/* Can be set by ACL */
 #ifndef DISABLE_TLS
  memset(&tls_out, 0, sizeof(tls_out));		/* Can be set by callout */
  tls_out.active.sock = -1;

